----------------------------------------------------------------------------------
-- Company: CSIRO
-- Engineer: David Humphrey (dave.humphrey@csiro.au)
-- 
-- Create Date: 06/04/2023 11:20:16 PM
-- Module Name: dataGen_Filter - Behavioral
-- Description: 
--  32 tap FIR filter, complex data, real weights.
--  Also includes phase correction and scaling
--
-- Precision and bit widths:
--  data in : 16 bit
--             * nominal range bits 14:0, = +/-16384 (for sinusoid), +/-1020 (for noise)
--  Filter  : 16 bit x 16 bit -> 32 bit result 
--             * Filter scales by 16384, so drop the low 14 bits to leave 
--               the data input the same amplitude
--             * Filter cannot overflow because 
--                - Data input is 14 bits, 
--                - filter taps are 14 bits, and only sum to a 15 bit value.
--  After filter : Use 24 bits = filter output (31:8)
--             * After dropping the low 8 bits, the
--               nominal source signal is in bits (21:6)
--  Phase correction : 24 bit data x 18 bit phase = 42 bit result => drop low 16 bits => 24 bit result
--             * complex phase has amplitude 65536
--             * 42 bit result -> drop low 16 bits, + a few high bits, to get a 24 bit result
--             * After scaling, nominal source signal is in bits 21:6
--  Scale : 24 bit data x 16 bit scale => 40 bit result
--             * Data output is the full 40 bits
--             * Scale factor requires dropping the low 16 bits after multiplication
--               (true scale factor is scale/65536)
--             * Nominal scaled source signal is in bits 37:22
--               e.g. if scale = 1, then sinusoid will sit in bits 21:6,
--                    and after dropping low 22 bits will have an amplitude of 0.25
-- (Outside this module: 
--             * After summing 40-bit values, drop the low 22 bits, and saturate to an 8 bit value
-- )
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
library common_lib;
USE common_lib.common_pkg.ALL;

entity dataGen_Filter is
    generic (
        USE_DUAL_DSP    : BOOLEAN   := TRUE
    
    );
    port(
        clk : in std_logic;
        ------------------------------------------------------------------------
        -- First data source data input
        i_re_src0 : in std_logic_vector(15 downto 0);
        i_im_src0 : in std_logic_vector(15 downto 0);
        i_preload_src0 : in std_logic; -- Preload inputs do not generate output
        -- 18 + 18 bit phase correction
        -- Phase and scale used are loaded prior to i_valid_src0, to be used for the outputs generated by i_valid_src0 (o_re, o_im).
        i_phase_src0 : in std_logic_vector(35 downto 0);
        i_phase_src0_valid : in std_logic;
        -- 16 bit scale factor to apply
        i_scale_src0 : in std_logic_vector(15 downto 0);
        i_src_count0 : in std_logic_vector(7 downto 0);
        i_scale_src0_valid : in std_logic;
        -- valid input cycles generate o_valid output cycles after some latency
        -- data output includes a contribution from i_re_src0, i_im_src0 in the cycle where i_valid_src0 = '1'
        i_valid_src0 : in std_logic;
        i_block_src0 : in std_logic;
        -- 2nd data source
        i_re_src1 : in std_logic_vector(15 downto 0);
        i_im_src1 : in std_logic_vector(15 downto 0);
        i_preload_src1 : in std_logic;
        i_phase_src1 : in std_logic_vector(35 downto 0);
        i_phase_src1_valid : in std_logic;
        -- 16 bit scale factor to apply
        i_scale_src1 : in std_logic_vector(15 downto 0);
        i_src_count1 : in std_logic_vector(7 downto 0);
        i_scale_src1_valid : in std_logic;
        i_valid_src1 : in std_logic;  -- Only one of valid_src0 and valid_src1 should be high at a time.
        i_block_src1 : in std_logic;
        ------------------------------------------------------------------------
        -- FIR taps (32 taps x 16 bits each)
        i_FIR_taps : in t_slv_16_arr(31 downto 0);
        i_FIR_valid_src0 : in std_logic;
        i_FIR_valid_src1 : in std_logic;
        ------------------------------------------------------------------------
        -- Data output
        o_re : out std_logic_vector(39 downto 0);
        o_im : out std_logic_vector(39 downto 0);
        o_src_count : out std_logic_vector(7 downto 0);
        o_block : out std_logic; -- first or second block of 16 samples.
        o_valid : out std_logic
    );
    -- prevent optimisation across module boundaries.
    attribute keep_hierarchy : string;
    attribute keep_hierarchy of dataGen_Filter : entity is "yes";
end dataGen_Filter;

architecture Behavioral of dataGen_Filter is

    -- complex multiplier
    -- 4 cycle latency
    component cmult_24x18
    port (
        aclk : IN STD_LOGIC;
        -- 24 bit input : re = 23:0, im = 47:24
        s_axis_a_tvalid : IN STD_LOGIC;
        s_axis_a_tdata : IN STD_LOGIC_VECTOR(47 DOWNTO 0);
        -- 18 bit input : re = 17:0, im = 41:24
        s_axis_b_tvalid : IN STD_LOGIC;
        s_axis_b_tdata : IN STD_LOGIC_VECTOR(47 DOWNTO 0);
        -- 43 bit output : re = 42:0, im = 90:48
        m_axis_dout_tvalid : OUT STD_LOGIC;
        m_axis_dout_tdata : OUT STD_LOGIC_VECTOR(95 DOWNTO 0));
    end component;

    component dsp_macro_pcin
    Port ( 
        CLK : in STD_LOGIC;
        PCIN : in STD_LOGIC_VECTOR ( 47 downto 0 );
        A : in STD_LOGIC_VECTOR ( 15 downto 0 );
        B : in STD_LOGIC_VECTOR ( 15 downto 0 );
        P : out STD_LOGIC_VECTOR ( 47 downto 0 )
        );
    end component;
    
    component dsp_macro_pcout
    Port ( 
        CLK : in STD_LOGIC;
        A : in STD_LOGIC_VECTOR ( 15 downto 0 );
        B : in STD_LOGIC_VECTOR ( 15 downto 0 );
        PCOUT : out STD_LOGIC_VECTOR ( 47 downto 0 );
        P : out STD_LOGIC_VECTOR ( 31 downto 0 )
    );
    end component;

    COMPONENT dsp_multi
    PORT (
        CLK : in STD_LOGIC;
        A : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
        B : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
        P : OUT STD_LOGIC_VECTOR(31 DOWNTO 0) 
        );
    END COMPONENT;
    
    signal state_src0 : t_slv_32_arr(31 downto 0);
    signal state_src1 : t_slv_32_arr(31 downto 0);
    signal FIR_taps_src0 : t_slv_16_arr(31 downto 0);
    signal FIR_taps_src1 : t_slv_16_arr(31 downto 0);
    signal valid_src0_del1, valid_src1_del1 : std_logic;

    attribute max_fanout : integer;
    attribute max_fanout of valid_src0_del1, valid_src1_del1 : signal is 256;

    signal valid_del2, valid_del3, valid_del4, valid_del5, valid_del6, valid_del7 : std_logic;
    signal filt_taps : t_slv_16_arr(31 downto 0);
    signal filt_din : t_slv_32_arr(31 downto 0);
    type t_signed_32_arr is array (INTEGER RANGE <>) of signed(31 DOWNTO 0);
    signal mult_Re : t_signed_32_arr(31 downto 0);
    signal mult_im : t_signed_32_arr(31 downto 0);
    
    signal multi_q_re   : t_slv_32_arr(31 downto 0);
    signal multi_q_im   : t_slv_32_arr(31 downto 0);
    
    signal sum01_re, sum23_re, sum45_re, sum67_re, sum89_re, sumAB_re, sumCD_re, sumEF_re : signed(31 downto 0);
    signal sum01_im, sum23_im, sum45_im, sum67_im, sum89_im, sumAB_im, sumCD_im, sumEF_im : signed(31 downto 0);
    
    signal sum01_re2, sum23_re2, sum45_re2, sum67_re2, sum89_re2, sumAB_re2, sumCD_re2, sumEF_re2 : signed(31 downto 0);
    signal sum01_im2, sum23_im2, sum45_im2, sum67_im2, sum89_im2, sumAB_im2, sumCD_im2, sumEF_im2 : signed(31 downto 0);
    
    signal sum0123_re, sum4567_re, sum89AB_re, sumCDEF_re : signed(31 downto 0);
    signal sum0123_im, sum4567_im, sum89AB_im, sumCDEF_im : signed(31 downto 0);
    signal sum01234567_re, sum89ABCDEF_re : signed(31 downto 0);
    signal sum01234567_im, sum89ABCDEF_im  : signed(31 downto 0);

    signal sum0123_re2, sum4567_re2, sum89AB_re2, sumCDEF_re2 : signed(31 downto 0);
    signal sum0123_im2, sum4567_im2, sum89AB_im2, sumCDEF_im2 : signed(31 downto 0);
    signal sum01234567_re2, sum89ABCDEF_re2, sum_re1, sum_re2 : signed(31 downto 0);
    signal sum01234567_im2, sum89ABCDEF_im2, sum_im1, sum_im2  : signed(31 downto 0);
    
    signal sum_re, sum_im : std_logic_vector(31 downto 0);
    
    signal phase_src0, phase_src1 : std_logic_vector(35 downto 0);
    signal scale_src0, scale_src1 : std_logic_vector(15 downto 0);
    signal phase_del : t_slv_36_arr(15 downto 0);
    signal scale_del : t_slv_16_arr(15 downto 0);
    signal sum_re_24bit, sum_im_24bit : std_logic_vector(23 downto 0);
    
    signal phase_mult_a : std_logic_vector(47 downto 0);
    signal phase_mult_b : std_logic_vector(47 downto 0);
    signal phase_mult_out : std_logic_vector(95 downto 0);
    signal phase_mult_out_re, phase_mult_out_im : std_logic_vector(39 downto 0);
    signal phase_re_round_up, phase_im_round_up : std_logic;
    signal phase_corrected_re, phase_corrected_im : std_logic_vector(23 downto 0);
    signal scale_mult_in_re, scale_mult_in_im : signed(23 downto 0);
    signal scale_mult_in_scale : signed(15 downto 0);
    signal scaled_re, scaled_im : signed(39 downto 0);
    signal valid_del : std_logic_vector(15 downto 0);
    signal src_count0, src_count1 : std_logic_vector(7 downto 0);
    signal src_count_del : t_slv_8_arr(15 downto 0); 
    
    signal valid_src0_block, valid_src1_block : std_logic := '0';
    signal block_del : std_logic_vector(15 downto 0) := x"0000";

    constant MULTI_ADDER_GEN_LOOP   : integer := 16;
    signal Re_PCOUT_connect         : t_slv_48_arr((MULTI_ADDER_GEN_LOOP-1) downto 0);
    signal Re_sum_stage_1           : t_slv_48_arr((MULTI_ADDER_GEN_LOOP-1) downto 0);

    signal Im_PCOUT_connect         : t_slv_48_arr((MULTI_ADDER_GEN_LOOP-1) downto 0);
    signal Im_sum_stage_1           : t_slv_48_arr((MULTI_ADDER_GEN_LOOP-1) downto 0);

    constant MULTI_GEN_LOOP         : integer := 32;

    attribute use_dsp : string;

    attribute use_dsp of mult_Re : signal is "no";
    attribute use_dsp of mult_im : signal is "no";

    attribute use_dsp of sum01_re, sum23_re, sum45_re, sum67_re, sum89_re, sumAB_re, sumCD_re, sumEF_re : signal is "no";
    attribute use_dsp of sum01_im, sum23_im, sum45_im, sum67_im, sum89_im, sumAB_im, sumCD_im, sumEF_im : signal is "no";
    
    attribute use_dsp of sum01_re2, sum23_re2, sum45_re2, sum67_re2, sum89_re2, sumAB_re2, sumCD_re2, sumEF_re2 : signal is "no";
    attribute use_dsp of sum01_im2, sum23_im2, sum45_im2, sum67_im2, sum89_im2, sumAB_im2, sumCD_im2, sumEF_im2 : signal is "no";

    attribute use_dsp of sum0123_re, sum4567_re, sum89AB_re, sumCDEF_re     : signal is "no";
    attribute use_dsp of sum0123_im, sum4567_im, sum89AB_im, sumCDEF_im     : signal is "no";
    attribute use_dsp of sum01234567_re, sum89ABCDEF_re                     : signal is "no";
    attribute use_dsp of sum01234567_im, sum89ABCDEF_im                     : signal is "no";

    attribute use_dsp of sum0123_re2, sum4567_re2, sum89AB_re2, sumCDEF_re2 : signal is "no";
    attribute use_dsp of sum0123_im2, sum4567_im2, sum89AB_im2, sumCDEF_im2 : signal is "no";
    attribute use_dsp of sum01234567_re2, sum89ABCDEF_re2, sum_re1, sum_re2 : signal is "no";
    attribute use_dsp of sum01234567_im2, sum89ABCDEF_im2, sum_im1, sum_im2 : signal is "no";
begin

    -----------------------------------------------------------------
    -- Timing optimisations
    -- generate loops for Im and Re
    -------------------------
    gen_dual : if (USE_DUAL_DSP) GENERATE
        gen_loop_dual_dsp : for i in 0 to (MULTI_ADDER_GEN_LOOP-1) GENERATE
    
            Re_s1_multi_only : dsp_macro_pcout
                port map ( 
                    CLK     => clk,
                    A       => filt_taps(2*i),
                    B       => filt_din(2*i)(15 downto 0),
                    PCOUT   => Re_PCOUT_connect(i),
                    P       => open
            );
            Re_s2_multi_add : dsp_macro_pcin
                port map ( 
                    CLK     => clk,
                    PCIN    => Re_PCOUT_connect(i),
                    A       => filt_taps((2*i)+1),
                    B       => filt_din((2*i)+1)(15 downto 0),
                    P       => Re_sum_stage_1(i)
            );
    
            Im_s1_multi_only : dsp_macro_pcout
                port map ( 
                    CLK     => clk,
                    A       => filt_taps(2*i),
                    B       => filt_din(2*i)(31 downto 16),
                    PCOUT   => Im_PCOUT_connect(i),
                    P       => open
            );
            Im_s2_multi_add : dsp_macro_pcin
                port map ( 
                    CLK     => clk,
                    PCIN    => Im_PCOUT_connect(i),
                    A       => filt_taps((2*i)+1),
                    B       => filt_din((2*i)+1)(31 downto 16),
                    P       => Im_sum_stage_1(i)
            );
        END GENERATE;

        sum_proc : process(clk)
        begin
            if rising_edge(clk) then
                sum0123_re  <= signed(Re_sum_stage_1(0)(31 downto 0)) + signed(Re_sum_stage_1(1)(31 downto 0));
                sum4567_re  <= signed(Re_sum_stage_1(2)(31 downto 0)) + signed(Re_sum_stage_1(3)(31 downto 0));
                sum89AB_re  <= signed(Re_sum_stage_1(4)(31 downto 0)) + signed(Re_sum_stage_1(5)(31 downto 0));
                sumCDEF_re  <= signed(Re_sum_stage_1(6)(31 downto 0)) + signed(Re_sum_stage_1(7)(31 downto 0));
                sum0123_re2 <= signed(Re_sum_stage_1(8)(31 downto 0)) + signed(Re_sum_stage_1(9)(31 downto 0));
                sum4567_re2 <= signed(Re_sum_stage_1(10)(31 downto 0)) + signed(Re_sum_stage_1(11)(31 downto 0));
                sum89AB_re2 <= signed(Re_sum_stage_1(12)(31 downto 0)) + signed(Re_sum_stage_1(13)(31 downto 0));
                sumCDEF_re2 <= signed(Re_sum_stage_1(14)(31 downto 0)) + signed(Re_sum_stage_1(15)(31 downto 0));


                sum0123_im  <= signed(Im_sum_stage_1(0)(31 downto 0)) + signed(Im_sum_stage_1(1)(31 downto 0));
                sum4567_im  <= signed(Im_sum_stage_1(2)(31 downto 0)) + signed(Im_sum_stage_1(3)(31 downto 0));
                sum89AB_im  <= signed(Im_sum_stage_1(4)(31 downto 0)) + signed(Im_sum_stage_1(5)(31 downto 0));
                sumCDEF_im  <= signed(Im_sum_stage_1(6)(31 downto 0)) + signed(Im_sum_stage_1(7)(31 downto 0));
                sum0123_im2 <= signed(Im_sum_stage_1(8)(31 downto 0)) + signed(Im_sum_stage_1(9)(31 downto 0));
                sum4567_im2 <= signed(Im_sum_stage_1(10)(31 downto 0)) + signed(Im_sum_stage_1(11)(31 downto 0));
                sum89AB_im2 <= signed(Im_sum_stage_1(12)(31 downto 0)) + signed(Im_sum_stage_1(13)(31 downto 0));
                sumCDEF_im2 <= signed(Im_sum_stage_1(14)(31 downto 0)) + signed(Im_sum_stage_1(15)(31 downto 0));

            end if;
        end process;
    END GENERATE;
    -------------------------
    gen_single_dsp : if (NOT USE_DUAL_DSP) GENERATE
        gen_loop_dsp : for i in 0 to (MULTI_GEN_LOOP-1) GENERATE
    
            Re_multi_only : dsp_multi
                port map (
                    CLK     => clk,
                    A       => filt_taps(i),
                    B       => filt_din(i)(15 downto 0),
                    P       => multi_q_re(i)
            );
    
            Im_multi_only : dsp_multi
                port map (
                    CLK     => clk,
                    A       => filt_taps(i),
                    B       => filt_din(i)(31 downto 16),
                    P       => multi_q_im(i)
            );
            
            mult_re(i)  <= signed(multi_q_re(i));
            mult_im(i)  <= signed(multi_q_im(i));
        END GENERATE;

        conditional_sum_proc : process(clk)
        begin
            if rising_edge(clk) then
                sum01_re <= mult_re(0) + mult_re(1);
                sum23_re <= mult_re(2) + mult_re(3);
                sum45_re <= mult_re(4) + mult_re(5);
                sum67_re <= mult_re(6) + mult_re(7);
                sum89_re <= mult_re(8) + mult_re(9);
                sumAB_re <= mult_re(10) + mult_re(11);
                sumCD_re <= mult_re(12) + mult_re(13);
                sumEF_re <= mult_re(14) + mult_re(15);
                sum01_re2 <= mult_re(16) + mult_re(17);
                sum23_re2 <= mult_re(18) + mult_re(19);
                sum45_re2 <= mult_re(20) + mult_re(21);
                sum67_re2 <= mult_re(22) + mult_re(23);
                sum89_re2 <= mult_re(24) + mult_re(25);
                sumAB_re2 <= mult_re(26) + mult_re(27);
                sumCD_re2 <= mult_re(28) + mult_re(29);
                sumEF_re2 <= mult_re(30) + mult_re(31);

                sum0123_re <= sum01_re + sum23_re;
                sum4567_re <= sum45_re + sum67_re;
                sum89AB_re <= sum89_re + sumAB_re;
                sumCDEF_re <= sumCD_re + sumEF_re;
                sum0123_re2 <= sum01_re2 + sum23_re2;
                sum4567_re2 <= sum45_re2 + sum67_re2;
                sum89AB_re2 <= sum89_re2 + sumAB_re2;
                sumCDEF_re2 <= sumCD_re2 + sumEF_re2;

                sum01_im <= mult_im(0) + mult_im(1);
                sum23_im <= mult_im(2) + mult_im(3);
                sum45_im <= mult_im(4) + mult_im(5);
                sum67_im <= mult_im(6) + mult_im(7);
                sum89_im <= mult_im(8) + mult_im(9);
                sumAB_im <= mult_im(10) + mult_im(11);
                sumCD_im <= mult_im(12) + mult_im(13);
                sumEF_im <= mult_im(14) + mult_im(15);
                sum01_im2 <= mult_im(16) + mult_im(17);
                sum23_im2 <= mult_im(18) + mult_im(19);
                sum45_im2 <= mult_im(20) + mult_im(21);
                sum67_im2 <= mult_im(22) + mult_im(23);
                sum89_im2 <= mult_im(24) + mult_im(25);
                sumAB_im2 <= mult_im(26) + mult_im(27);
                sumCD_im2 <= mult_im(28) + mult_im(29);
                sumEF_im2 <= mult_im(30) + mult_im(31);

                sum0123_im <= sum01_im + sum23_im;
                sum4567_im <= sum45_im + sum67_im;
                sum89AB_im <= sum89_im + sumAB_im;
                sumCDEF_im <= sumCD_im + sumEF_im;
                sum0123_im2 <= sum01_im2 + sum23_im2;
                sum4567_im2 <= sum45_im2 + sum67_im2;
                sum89AB_im2 <= sum89_im2 + sumAB_im2;
                sumCDEF_im2 <= sumCD_im2 + sumEF_im2;

            end if;
        end process;
    END GENERATE;
    


    process(clk)
    begin
        if rising_edge(clk) then
            
            if i_preload_src0 = '1' or i_valid_src0  = '1' then
                state_src0(0) <= i_im_src0 & i_re_src0;
                state_src0(31 downto 1) <= state_src0(30 downto 0);
            end if;

            if i_preload_src1 = '1' or i_valid_src1  = '1' then
                state_src1(0) <= i_im_src1 & i_re_src1;
                state_src1(31 downto 1) <= state_src1(30 downto 0);
            end if;     
            
            if i_FIR_valid_src0 = '1' then
                
                FIR_taps_src0 <= i_FIR_taps;
                
            end if;
            
            if i_FIR_valid_src1 = '1' then
                
                FIR_taps_src1 <= i_FIR_taps;
                
            end if;

            if i_phase_src0_valid = '1' then
                phase_src0 <= i_phase_src0;
            end if;
            if i_phase_src1_valid = '1' then
                phase_src1 <= i_phase_src1;
            end if;
            if i_scale_src0_valid = '1' then
                scale_src0 <= i_scale_src0;
                src_count0 <= i_src_count0;
            end if;
            if i_scale_src1_valid = '1' then
                scale_src1 <= i_scale_src1;
                src_count1 <= i_src_count1;
            end if;
            
            valid_src0_del1 <= i_valid_src0;
            valid_src1_del1 <= i_valid_src1;
            
            valid_src0_block <= i_block_src0;
            valid_src1_block <= i_block_src1;
            
            if valid_src0_del1 = '1' then
                filt_taps <= FIR_taps_src0;
                filt_din <= state_src0;
                phase_del(0) <= phase_src0;
                scale_del(0) <= scale_src0;
                src_count_del(0) <= src_count0;
                valid_del(0) <= '1';
                block_del(0) <= valid_src0_block;
            elsif valid_src1_del1 = '1' then
                filt_taps <= FIR_taps_src1;
                filt_din <= state_src1;
                phase_del(0) <= phase_src1;
                scale_del(0) <= scale_src1;
                src_count_del(0) <= src_count1;
                valid_del(0) <= '1';
                block_del(0) <= valid_src1_block;
            else
                filt_taps <= (others => (others => '0'));
                filt_din <= (others => (others => '0'));
                phase_Del(0) <= (others => '0');
                scale_del(0) <= (others => '0');
                valid_del(0) <= '0';
            end if;
            
            phase_del(15 downto 1) <= phase_del(14 downto 0);
            scale_del(15 downto 1) <= scale_del(14 downto 0);
            src_count_del(15 downto 1) <= src_count_del(14 downto 0);
            valid_del(15 downto 1) <= valid_del(14 downto 0);
            block_del(15 downto 1) <= block_del(14 downto 0);
            
            valid_del2 <= valid_src0_del1 or valid_src1_del1;
            valid_del3 <= valid_del2;
            valid_del4 <= valid_del3;
            valid_del5 <= valid_del4;
            valid_del6 <= valid_del5;
            valid_del7 <= valid_del6;
            
            -- for i in 0 to 31 loop
            --     -- 16 bit inputs, 32 bit result.
            --     -- The input is either :
            --     --     (1) A sinusoid with amplitude +/-16384
            --     --  or (2) pseudo-random noise, amplitude at most +/-1020
            --     -- Filter taps are at most ~16000.
            --     -- After the interpolation filter is applied, 
            --     -- Maximum output is about 16384 * 16000 ~ 2^28
            --     -- So after summing the multiplications, the result will always fit in 32 bits.
            --     mult_re(i) <= signed(filt_taps(i)) * signed(filt_din(i)(15 downto 0));
            --     mult_im(i) <= signed(filt_taps(i)) * signed(filt_din(i)(31 downto 16));
            -- end loop;

            sum01234567_re <= sum0123_re + sum4567_re;
            sum89ABCDEF_re <= sum89AB_re + sumCDEF_re;
            sum01234567_re2 <= sum0123_re2 + sum4567_re2;
            sum89ABCDEF_re2 <= sum89AB_re2 + sumCDEF_re2;
            
            sum_re1 <= sum01234567_re + sum89ABCDEF_re;
            sum_re2 <= sum01234567_re2 + sum89ABCDEF_re2;
            
            sum_re <= std_logic_vector(sum_re1 + sum_re2);

            sum01234567_im <= sum0123_im + sum4567_im;
            sum89ABCDEF_im <= sum89AB_im + sumCDEF_im;
            sum01234567_im2 <= sum0123_im2 + sum4567_im2;
            sum89ABCDEF_im2 <= sum89AB_im2 + sumCDEF_im2;
            
            sum_im1 <= sum01234567_im + sum89ABCDEF_im;
            sum_im2 <= sum01234567_im2 + sum89ABCDEF_im2;
            
            sum_im <= std_logic_vector(sum_im1 + sum_im2);
            
            -- Convergent rounding - if odd and a tie, then +1
            if ((sum_re(7 downto 0) = "10000000" and sum_re(8) = '1') or
                (sum_re(6 downto 0) /= "0000000" and sum_re(7) = '1')) then
                sum_re_24bit <= std_logic_vector(unsigned(sum_re(31 downto 8)) + 1);
            else
                sum_re_24bit <= sum_re(31 downto 8);
            end if;
            
            if ((sum_im(7 downto 0) = "10000000" and sum_im(8) = '1') or
                (sum_im(6 downto 0) /= "0000000" and sum_im(7) = '1')) then
                sum_im_24bit <= std_logic_vector(unsigned(sum_im(31 downto 8)) + 1);
            else
                sum_im_24bit <= sum_im(31 downto 8);
            end if;

            -- Convergent Rounding for phase multiplier output
            -- Drop low 16 bits
            phase_mult_out_re <= phase_mult_out(39 downto 0);
            phase_mult_out_im <= phase_mult_out(87 downto 48);
            if ((phase_mult_out(15 downto 0) = "1000000000000000" and phase_mult_out(16) = '1') or
                (phase_mult_out(14 downto 0) /= "000000000000000" and phase_mult_out(15) = '1')) then
                phase_re_round_up <= '1';
            else
                phase_re_round_up <= '0';
            end if;
            
            if ((phase_mult_out(63 downto 48) = "1000000000000000" and phase_mult_out(64) = '1') or
                (phase_mult_out(62 downto 48) /= "000000000000000" and phase_mult_out(63) = '1')) then
                phase_im_round_up <= '1';
            else
                phase_im_round_up <= '0';
            end if;
            
            if phase_re_round_up = '1' then
                phase_corrected_re <= std_logic_vector(unsigned(phase_mult_out_re(39 downto 16)) + 1);
            else
                phase_corrected_re <= phase_mult_out_re(39 downto 16);
            end if;
            if phase_im_round_up = '1' then
                phase_corrected_im <= std_logic_vector(unsigned(phase_mult_out_im(39 downto 16)) + 1);
            else
                phase_corrected_im <= phase_mult_out_im(39 downto 16);
            end if;            
            
            scale_mult_in_re <= signed(phase_corrected_re);
            scale_mult_in_im <= signed(phase_corrected_im);
            -- phase_mult_out aligns with del(11), phase_corrected_re aligns with del(13)
            scale_mult_in_scale <= signed(scale_del(13));
            
            scaled_re <= scale_mult_in_re * scale_mult_in_scale;
            scaled_im <= scale_mult_in_im * scale_mult_in_scale;
            
            o_re <= std_logic_vector(scaled_re);
            o_im <= std_logic_vector(scaled_im);
            o_src_count <= src_count_del(15);
            o_valid <= valid_del(15);
            o_block <= block_del(15);
        end if;
    end process;
    
    -- Phase correction complex multiplier
    phase_mult_a <= sum_im_24bit & sum_re_24bit;
    -- phase_del(7) since 7 cycle latency from filt_din to sum_re_24bit
    phase_mult_b(23 downto 0)  <= "000000" & phase_del(7)(17 downto 0);
    phase_mult_b(47 downto 24) <= "000000" & phase_del(7)(35 downto 18);
    
    -- 4 clock latency
    phase_correctioni : cmult_24x18
    port map (
        aclk => clk,
        -- 24 bit input : re = 23:0, im = 47:24
        s_axis_a_tvalid => '1',           -- in std_logic;
        s_axis_a_tdata  => phase_mult_a,  -- in (47:0);
        -- 18 bit input : re = 17:0, im = 41:24
        s_axis_b_tvalid => '1', -- in std_logic;
        s_axis_b_tdata  => phase_mult_b, -- in(47:0)
        -- 43 bit output : re = 42:0, im = 90:48
        m_axis_dout_tvalid => open,
        m_axis_dout_tdata  => phase_mult_out -- out (95:0)
    );

    
end Behavioral;
